/*    Beejay*/
#property copyright "Copyright  2009, DKeN"
#property link      "http://www.dken.biz"
//----
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

#property indicator_width1 1
#property indicator_width2 1

//----
double CrossUp[];
double CrossDown[];
extern int Fast=8;
extern int Slow=26;
extern double cciFilter=0.0;
extern double rsiFilter=0.0;

extern bool UseAlert = true;

extern bool alertsMessage=true;
extern bool alertsEmail=false;
extern bool alertsSound=true;
extern double cfg_iRiskPercent=1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexEmptyValue(0,0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
   SetIndexEmptyValue(1,0);
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start() 
  {
   int limit, i, cross,cci1,cci2,rsi;
   double sar;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   datetime cur;
   for(i=limit;i>=0;i--){
      cross=get_cross(i);
      cci1=get_cci(55,i);   
      cci2=get_cci(34,i);
      rsi=get_rsi(i);
      sar=iSAR(NULL,0,0.02,0.2,i);
      cur=iTime(Symbol(),0,i);
      double svecha=Close[i]-Open[i];
      
      if(cross==1 && cci1==1 && cci2==1 && rsi==1 && sar<Close[i] && sar!=0 && is_trend(1,i)==1 && svecha>0){ CrossUp[i]=Close[i]; i-=5;}
      if(cross==-1 && cci1==-1 && cci2==-1 && rsi==-1 && sar>Close[i] && sar!=0 && is_trend(-1,i)==-1 && svecha<0){CrossDown[i]=Close[i]; i-=5;}
      
   }
     
      cross=get_cross(0);
      cci1=get_cci(55,0);   
      cci2=get_cci(34,0);
      rsi=get_rsi(0);
      sar=iSAR(NULL,0,0.02,0.2,1);
      double lot=get_lot(Symbol(),sar,Ask);
      svecha=Close[0]-Open[0];
      int signal=-1;
      string sSignal="nothing";
      if(cross==1 && cci1==1 && cci2==1 && rsi==1 && sar<Close[0] && sar!=0 && is_trend(1,0)==1 && svecha>0){ doAlert("up"); signal=OP_BUY; sSignal="BUY";}
      if(cross==-1 && cci1==-1 && cci2==-1 && rsi==-1 && sar>Close[0] && sar!=0 && is_trend(-1,0)==-1 && svecha<0){doAlert("down"); signal=OP_SELL; sSignal="SELL";}
      
      string sCross="false",scci1="false",scci2="false",srsi="false";
      if(cross!=0) sCross="true";
      if(cci2!=0) scci1="true";
      if(cci1!=0) scci2="true";
      if(rsi!=0) srsi="true";
      
      
      Comment("Signal: ",sSignal,"\n",
         "Cross Signal : ",sCross,"\n",
         "CCI1 Signal  : ",scci1,"\n",
         "CCI2 Signal  : ",scci2,"\n",
         "RSI Signal   : ",srsi,"\n",
         "Lot: ",lot,"\n",
         "StopLevel: ",sar,"\n");
//----     
   return(0);
  }
  
int is_trend(int type,int pos){
   double ma1,ma2;
   
   for(int i=pos;i<pos+3;i++){
   ma1=iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,i);
   ma2=iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,i+1);
   if(ma1>ma2 && type==1) continue; else
   if(ma1<ma2 && type==-1) continue;
   return (0);
   }
   
   return(type);
}  
int get_cross(int pos){
   double fma1,fma2,sma1,sma2;
   fma1=iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,pos);
   sma1=iMA(NULL,0,Slow,0,MODE_SMA,PRICE_CLOSE,pos);  
   
   for(int i=pos+1;i<pos+10;i++){
      
   fma2=iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,i);
   sma2=iMA(NULL,0,Slow,0,MODE_SMA,PRICE_CLOSE,i);
   
   if(fma2<sma2 && fma1>sma1){return (1);}
   if(fma2>sma2 && fma1<sma1){return (-1);}
   
   }
   return (0); //not signal
}

int get_cci(int period,int pos){
   double cci1,cci2;
   cci1=iCCI(NULL,0,period,PRICE_CLOSE,pos);
   
   for(int i=pos+1;i<pos+10;i++){
   
   cci2=iCCI(NULL,0,period,PRICE_CLOSE,i);
  

   if(cci1>0 && cci2<cci1+cciFilter && cci2<0){return (1);}
   if(cci1<0 && cci2>cci1+cciFilter && cci2>0){return (-1);}
   
   }
      
   return (0);
}

int get_rsi(int pos){
   double rsi1,rsi2;
   rsi1=iRSI(NULL,0,26,PRICE_CLOSE,pos);
   
   for(int i=pos+1;i<pos+10;i++){
   
   rsi2=iRSI(NULL,0,26,PRICE_CLOSE,i);

   if(rsi1>48 && rsi1>rsi2+rsiFilter && rsi2<48){return (1);}
   if(rsi1<48 && rsi1<rsi2-rsiFilter && rsi2>48){return (-1);}
   }
      
   return (0);
}
double get_lot(string name,double stoplevel,double openlevel){
   double lot=0;
   if(stoplevel<=0 || openlevel<=0) return (0);
   
   
   int    TipInstrumenta=0;  
   double BazCours=0;
   double dCof=1;
   string SMB;   
   double stop=0;
     
 // ---------    (, , ) --------------
   TipInstrumenta=StringFind(name,"USD",0); 
   SMB=StringSubstr(name,0,3); // 
   BazCours=MarketInfo(SMB+"USD",MODE_BID);     
   double Dig10=1;
   if(MarketInfo(name,MODE_DIGITS)==5) Dig10=10;
   double dBid=MarketInfo(name,MODE_BID);
   
   if(TipInstrumenta==3){// , . EurUsd
     dCof=10;
     Dig10=10;
   }
   if(TipInstrumenta==0){// , . UsdJpy
     dCof=10/dBid;
     Dig10=10;
   }  
   if(TipInstrumenta==-1){//-,  EurJpy
     dCof=10*BazCours/dBid;
     Dig10=10;
   }  
     double dPoint=MarketInfo(name,MODE_POINT);
     
     lot=NormalizeDouble(0.0001*cfg_iRiskPercent*AccountFreeMargin()*dPoint*Dig10/MathAbs(openlevel-stoplevel),2);       
     
     if(lot>MarketInfo(name,MODE_MAXLOT)) lot=MarketInfo(name,MODE_MAXLOT);
     if(lot<MarketInfo(name,MODE_MINLOT)) lot=MarketInfo(name,MODE_MINLOT);
      
     //Print(lot); 
     //if(lot*1000*dBid>0.8*AccountFreeMargin()) Print("LOT: ",lot," ActiveMargin > FreeMargin");
      
     return (lot);     
  }  
//+------------------------------------------------------------------+

void doAlert(string doWhat)
  {
      if(UseAlert==false) return;
      
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
//----
     if (previousAlert!=doWhat || previousTime!=Time[0]) 
     {
      previousAlert =doWhat;
      previousTime  =Time[0];
//----
      string sPeriod="";
      switch(Period()){
      case PERIOD_M1: sPeriod="M1"; break;
      case PERIOD_M5: sPeriod="M5"; break;
      case PERIOD_M15: sPeriod="M15"; break;
      case PERIOD_M30: sPeriod="M30"; break;
      case PERIOD_H1: sPeriod="H1"; break;
      case PERIOD_H4: sPeriod="H4"; break;
      case PERIOD_D1: sPeriod="D1"; break;
      case PERIOD_W1: sPeriod="W1"; break;
      case PERIOD_MN1: sPeriod="MN1"; break;
      }
      message= StringConcatenate(Symbol()," Period: ",sPeriod," Trend changed to ",doWhat);
      if (alertsMessage) Alert(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MySystem "),message);
      if (alertsSound)   PlaySound("alert2.wav");
     }
  }